<?php

require_once ADDON_DIR . DS . 'classes' . DS . 'Products.php';
require_once ADDON_DIR . DS . 'core' . DS . 'class.MG_Modules.php';
require_once ADDON_DIR . DS . 'core' . DS . 'functions.php';
require_once ADDON_DIR . DS . 'classes' . DS . 'API.php';

class AddonsSync
{
    private $products = [];
    private $targetProducts = [];

    public function __construct($id = null, $create = false)
    {
        $products = new Products($id);
        //get reseller's product IDs
        $this->products = $products->getProducts();
        //get target product IDs
        $this->targetProducts = $products->getTargetProducts();
    }

    public function addonsSync()
    {
        //prepate product target IDs
        $ids = [];
        foreach ($this->targetProducts as $targetProduct) {
            if (!in_array($targetProduct['taget_product_id'], $ids)) {
                $ids[] = $targetProduct['taget_product_id'];
            }
        }

        //send request with product target IDs        
        $api = new API();
        $response = $api->getProductsAddons($ids);
        foreach ($response['products'] as $targetProductID => $product) {
            $prodAddon = [];
            foreach ($this->targetProducts as $relation) {
                if ($relation['taget_product_id'] == $targetProductID) {
                    $productID = $relation['product_id'];

                    foreach ($product['addons'] as $addon) {
                        //generate new addon
                        $prodAddon[] = [
                            'name' => $addon['name'],
                            'description' => $addon['description'],
                            'billingcycle' => $addon['billingcycle'],
                            'tax' => $addon['tax'],
                            'showorder' => $addon['showorder'], //?
                            'downloads' => $addon['downloads'], //?
                            'autoactivate' => $addon['autoactivate'], //?
                            'suspendproduct' => $addon['suspendproduct'], //?
                            'welcomeemail' => $addon['welcomeemail'], //?
                            'type' => $addon['type'],
                            'module' => $addon['module'],
                            'server_group_id' => $addon['server_group_id'], //?
                            'weight' => $addon['weight'],
                            'autolinkby' => $addon['autolinkby'],
                            'pricing' => $addon['pricing'],
                            'custom_fields' => $addon['custom_fields'],
                        ];
                    }

                    $addons[$productID] = $prodAddon;
                }
            }
        }
        //generate addons    
        $this->generateAddons($addons);
    }

    private function generateAddons($addons)
    {
        foreach ($addons as $productID => $productAddons) {
            $assignedAddons = $this->getAssignedAddons($productID);
            foreach ($productAddons as $addon) {
                $existingAddon = $this->checkIfAddonExist($addon['name']);
                if ($existingAddon == false) {
                    mysql_query_safe('INSERT INTO tbladdons(name, packages, description, billingcycle, tax, showorder, downloads, autoactivate, suspendproduct, welcomeemail, type, module, server_group_id, weight, autolinkby) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)',
                        [
                            $addon['name'],
                            $productID,
                            $addon['description'],
                            $addon['billingcycle'],
                            $addon['tax'],
                            $addon['showorder'],
                            '',
                            $addon['autoactivate'], //?
                            $addon['suspendproduct'], //?
                            $addon['welcomeemail'], //?
                            $addon['type'],
                            '',
                            0, //?
                            $addon['weight'],
                            $addon['autolinkby'],
                        ]);

                    $addon_id = mysql_last_id();
                    if (isset($addon['pricing'])) {
                        //pricing sync
                        foreach ($addon['pricing'] as $currency_id => $values) {
                            mysql_query_safe('INSERT INTO `tblpricing` (`type`,`currency`,`relid`,`msetupfee`,`qsetupfee`,`ssetupfee`,`asetupfee`,`bsetupfee`,`tsetupfee`,`monthly`,`quarterly`,`semiannually`,`annually`,`biennially`,`triennially`) VALUES("addon",?,?,?,?,?,?,?,?,?,?,?,?,?,?)',
                                [
                                    $currency_id,
                                    $addon_id,
                                    isset($values['msetupfee']) ? (float)$values['msetupfee'] : 0,
                                    isset($values['qsetupfee']) ? (float)$values['qsetupfee'] : 0,
                                    isset($values['ssetupfee']) ? (float)$values['ssetupfee'] : 0,
                                    isset($values['asetupfee']) ? (float)$values['asetupfee'] : 0,
                                    isset($values['bsetupfee']) ? (float)$values['bsetupfee'] : 0,
                                    isset($values['tsetupfee']) ? (float)$values['tsetupfee'] : 0,
                                    isset($values['monthly']) ? (float)$values['monthly'] : 0,
                                    isset($values['quarterly']) ? (float)$values['quarterly'] : 0,
                                    isset($values['semiannually']) ? (float)$values['semiannually'] : 0,
                                    isset($values['annually']) ? (float)$values['annually'] : 0,
                                    isset($values['biennially']) ? (float)$values['biennially'] : 0,
                                    isset($values['triennially']) ? (float)$values['triennially'] : 0,
                                ]);
                        }
                    }
                } else {
                    //check if product is assigned to addon
                    $assignedPackages = [];
                    if ($existingAddon['packages'] != "") {
                        $assignedPackages = explode(',', $existingAddon['packages']);
                    }

                    if (!in_array($productID, $assignedPackages)) {
                        $assignedPackages[] = $productID;
                    }
                    $packages = implode(',', $assignedPackages);

                    $addon_id = $existingAddon['id'];

                    mysql_query_safe('UPDATE tbladdons SET packages = ?, description = ?, billingcycle = ?, tax = ?, showorder = ?, downloads = ?, autoactivate = ?, suspendproduct = ?, welcomeemail = ?, type = ?, module = ?, server_group_id = ?, weight = ?, autolinkby = ? WHERE id = ?',
                        [
                            $packages,
                            isset($addon['description']) ? $addon['description'] : null,
                            $addon['billingcycle'],
                            isset($addon['tax']) ? (int)$addon['tax'] : 0,
                            isset($addon['showorder']) ? (int)$addon['showorder'] : 0,
                            isset($addon['downloads']) ? $addon['downloads'] : '',
                            isset($addon['autoactivate']) ? $addon['autoactivate'] : null,
                            isset($addon['suspendproduct']) ? (int)$addon['suspendproduct'] : 0,
                            isset($addon['welcomeemail']) ? (int)$addon['welcomeemail'] : 0,
                            $addon['type'],
                            '',
                            0,
                            isset($addon['weight']) ? (int)$addon['weight'] : 0,
                            isset($addon['autolinkby']) ? (int)$addon['autolinkby'] : null,
                            $addon_id,
                        ]);
                }

                if (!empty($addon['custom_fields'])) {
                    foreach ($addon['custom_fields'] as $customField) {
                        $existingCustomField = $this->checkIfCustomFieldExist($customField['fieldname'], $addon_id);
                        if ($existingCustomField == false) {
                            mysql_query_safe('INSERT INTO `tblcustomfields`(`type`, `relid`, `fieldname`, `fieldtype`, `description`, `regexpr`, `adminonly`, `required`, `showorder`, `showinvoice`, `sortorder`, `created_at`, `updated_at`) VALUES(?,?,?,?,?,?,?,?,?,?,?,NOW(),NOW())',
                                [
                                    'addon',
                                    $addon_id,
                                    $customField['fieldname'],
                                    $customField['fieldtype'],
                                    $customField['description'],
                                    $customField['regexpr'],
                                    $customField['adminonly'],
                                    $customField['required'],
                                    $customField['showorder'],
                                    $customField['showinvoice'],
                                    0,
                                ]);
                        } else {
                            $customFieldID = $existingCustomField['id'];
                            mysql_query_safe('UPDATE `tblcustomfields` SET fieldtype = ?, description = ?, regexpr = ?, adminonly = ?, required = ?, showorder = ?, showinvoice = ?, updated_at = ? WHERE id = ?',
                                [
                                    $customField['fieldtype'],
                                    $customField['description'],
                                    $customField['regexpr'],
                                    $customField['adminonly'],
                                    $customField['required'],
                                    $customField['showorder'],
                                    $customField['showinvoice'],
                                    date('Y-m-d H:i:s'),
                                    $customFieldID,
                                ]);
                        }
                    }
                }
                //prepare array of addons to unassing product
                foreach ($assignedAddons as $key => $addonID) {
                    if ($addon_id == $addonID) {
                        unset($assignedAddons[$key]);
                    }
                }
            }

            //unasign productID from addons
            $this->unassignProductFromAddon($productID, $assignedAddons);
        }
    }

    private function checkIfAddonExist($name, $type = null, $id = null)
    {
        $q = mysql_query_safe('SELECT * FROM tbladdons WHERE name = ?', [$name]);

        return mysql_extract_assoc($q);
    }

    private function checkIfCustomFieldExist($fieldname, $relid)
    {
        $q = mysql_query_safe('SELECT * FROM `tblcustomfields` WHERE `fieldname` = ? AND `relid` = ? AND `type` = ?',
            [$fieldname, $relid, 'addon']);

        return mysql_extract_assoc($q);
    }

    private function unassignProductFromAddon($productID, $addons)
    {
        foreach ($addons as $addonID) {
            $q = mysql_query_safe('SELECT * FROM tbladdons WHERE id = ?', [$addonID]);
            $addon = mysql_extract_assoc($q);
            if ($addon != false) {

                $assignedPackages = [];
                if ($addon['packages'] != "") {
                    $assignedPackages = explode(',', $addon['packages']);
                }

                foreach ($assignedPackages as $key => $package) {
                    if ($package == $productID) {
                        unset($assignedPackages[$key]);
                    }
                }
                $packages = implode(',', $assignedPackages);
            }

            mysql_query_safe('UPDATE tbladdons SET packages = ? WHERE id = ?', [$packages, $addonID]);
        }
    }

    private function getAssignedAddons($id)
    {
        $q = mysql_query_safe('SELECT * FROM `tbladdons`');

        $assignedAddons = [];
        while ($row = mysql_extract_assoc($q)) {
            if ($row['packages'] != "") {
                $assignedPackages = explode(',', $row['packages']);
            }

            if (in_array($id, $assignedPackages)) {
                $assignedAddons[] = $row['id'];
            }
        }

        return $assignedAddons;
    }
}
