<?php

if (!defined('WHMCS')) {
    die('This is WHMCS page!');
}

require_once ADDON_DIR . DS . 'classes' . DS . 'ConfigOptionsSync.php';
require_once ADDON_DIR . DS . 'classes' . DS . 'AddonsSync.php';
ob_clean();
function HostwindsReseller_simpleInsertQuery($table, array $params)
{
    $placeholders = implode(',', array_fill(0, count($params), '?'));
    $keys = implode(',', array_keys($params));
    $query = 'INSERT INTO ' . $table . '(' . $keys . ') VALUES(' . $placeholders . ')';
    return mysql_query_safe($query, array_values($params));
}

try {
    $mod = isset($_REQUEST['mod']) ? $_REQUEST['mod'] : 'HostwindsReseller';
    $module = HostwindsReseller_getmodule($mod);


    $response = $module->getProductsFromSeller();
    if (!$response->isSuccess()) {
        throw new Exception('Unable to get product list - ' . $response->getMessage());
    }

    $productGroups = $response->json['products'];

    $messages = [];
    foreach ($productGroups as $products) {
        foreach ($products as $prod) {
            if (!isset($_POST['products'][$prod['id']])) {
                continue;
            }


            $detailsResponse = $module->getProductDetailsForCreation($prod['id']);
            if (!$detailsResponse->isSuccess()) {
                throw new Exception('Unable to get details for remote product "' . $prod['name'] . '"');
            }

            $product = isset($detailsResponse->json['products'][$prod['id']]) ? $detailsResponse->json['products'][$prod['id']] : null;
            if ($product) {

                $multiplier = isset($_POST['products'][$prod['id']]) && $_POST['products'][$prod['id']] !== '' ?
                    (int)$_POST['products'][$prod['id']] / 100 :
                    1;
                $configOptionsMultiplier = isset($_POST['config_options'][$prod['id']]) && $_POST['config_options'][$prod['id']] !== '' ?
                    (int)$_POST['config_options'][$prod['id']] / 100 :
                    1;

                $welcomeEmailId = '0';
                if ($product['template_subject']) {
                    HostwindsReseller_simpleInsertQuery('tblemailtemplates', [
                        'type' => 'product',
                        'name' => 'Welcome Email for ' . $product['name'],
                        'subject' => $product['template_subject'],
                        'message' => html_entity_decode($product['template_message']),
                        'attachments' => '',
                        'fromname' => '',
                        'fromemail' => '',
                        'disabled' => '',
                        'custom' => '1',
                        'language' => '',
                        'copyto' => '',
                        'plaintext' => '0',
                    ]);
                    $welcomeEmailId = mysql_last_id();
                }

                $firstdetails = [];
                foreach ($product['product_details'] as $productdet) {
                    $firstdetails = $productdet;
                    break;
                }

                HostwindsReseller_simpleInsertQuery('tblproducts', [
                    'type' => $firstdetails['type'],
                    'gid' => $_POST['group_id'],
                    'name' => $product['name'],
                    'description' => $product['description'],
                    'hidden' => '',
                    'showdomainoptions' => $firstdetails['showdomainoptions'],
                    'welcomeemail' => $welcomeEmailId,
                    'stockcontrol' => '0',
                    'qty' => '0',
                    'proratabilling' => '',
                    'proratadate' => '0',
                    'proratachargenextmonth' => '0',
                    'paytype' => $firstdetails['paytype'],
                    'allowqty' => '0',
                    'subdomain' => '',
                    'autosetup' => 'payment',
                    'servertype' => $mod,
                    'servergroup' => '0',
                    'configoption1' => '',
                    'configoption2' => '',
                    'configoption3' => '',
                    'configoption4' => '',
                    'configoption5' => '',
                    'configoption6' => '',
                    'configoption7' => '',
                    'configoption8' => '',
                    'configoption9' => '',
                    'configoption10' => '',
                    'configoption11' => '',
                    'configoption12' => '',
                    'configoption13' => '',
                    'configoption14' => '',
                    'configoption15' => '',
                    'configoption16' => '',
                    'configoption17' => '',
                    'configoption18' => '',
                    'configoption19' => '',
                    'configoption20' => '',
                    'configoption21' => '',
                    'configoption22' => '',
                    'configoption23' => '',
                    'configoption24' => '',
                    'freedomain' => '',
                    'freedomainpaymentterms' => '',
                    'freedomaintlds' => '',
                    'recurringcycles' => '0',
                    'autoterminatedays' => '0',
                    'autoterminateemail' => '0',
                    //'upgradepackages' => 'N;',
                    'configoptionsupgrade' => '',
                    'billingcycleupgrade' => '',
                    //'upgradechargefullcycle' => '0',
                    'upgradeemail' => '0',
                    'overagesenabled' => '0',
                    'overagesdisklimit' => '0',
                    'overagesbwlimit' => '0',
                    'overagesdiskprice' => '0.000',
                    'overagesbwprice' => '0.000',
                    'tax' => '0',
                    'affiliateonetime' => '',
                    'affiliatepaytype' => '',
                    'affiliatepayamount' => '0.00',
                    //'downloads' => '',
                    '`order`' => '0',
                    'retired' => '0',
                ]);

                $productId = mysql_last_id();

                $c = $mod . '_Product';

                $c::setupDbTable();
                $p = new $c($productId);
                $p->saveConfig('target_product', $prod['id']);

                foreach ($product['product_details'] as $currency => $d) {
                    if (isset($d['msetupfee'])) {
                        $qcurr = mysql_extract_assoc(mysql_query_safe('SELECT id FROM tblcurrencies WHERE code = ?',
                            [$currency]));

                        if (isset($qcurr['id'])) {
                            HostwindsReseller_simpleInsertQuery('tblpricing', [
                                'type' => 'product',
                                'currency' => $qcurr['id'],
                                'relid' => $productId,
                                'msetupfee' => in_array($d['msetupfee'],
                                    ['-1.00', '0.00']) ? $d['msetupfee'] : $d['msetupfee'] * $multiplier,
                                'qsetupfee' => in_array($d['qsetupfee'],
                                    ['-1.00', '0.00']) ? $d['qsetupfee'] : $d['qsetupfee'] * $multiplier,
                                'ssetupfee' => in_array($d['ssetupfee'],
                                    ['-1.00', '0.00']) ? $d['ssetupfee'] : $d['ssetupfee'] * $multiplier,
                                'asetupfee' => in_array($d['asetupfee'],
                                    ['-1.00', '0.00']) ? $d['asetupfee'] : $d['asetupfee'] * $multiplier,
                                'bsetupfee' => in_array($d['bsetupfee'],
                                    ['-1.00', '0.00']) ? $d['bsetupfee'] : $d['bsetupfee'] * $multiplier,
                                'tsetupfee' => in_array($d['tsetupfee'],
                                    ['-1.00', '0.00']) ? $d['tsetupfee'] : $d['tsetupfee'] * $multiplier,
                                'monthly' => in_array($d['monthly'],
                                    ['-1.00', '0.00']) ? $d['monthly'] : $d['monthly'] * $multiplier,
                                'quarterly' => in_array($d['quarterly'],
                                    ['-1.00', '0.00']) ? $d['quarterly'] : $d['quarterly'] * $multiplier,
                                'semiannually' => in_array($d['semiannually'],
                                    ['-1.00', '0.00']) ? $d['semiannually'] : $d['semiannually'] * $multiplier,
                                'annually' => in_array($d['annually'],
                                    ['-1.00', '0.00']) ? $d['annually'] : $d['annually'] * $multiplier,
                                'biennially' => in_array($d['biennially'],
                                    ['-1.00', '0.00']) ? $d['biennially'] : $d['biennially'] * $multiplier,
                                'triennially' => in_array($d['triennially'],
                                    ['-1.00', '0.00']) ? $d['triennially'] : $d['triennially'] * $multiplier,
                            ]);
                        }
                    }
                }
                //generate default custom 
                $module->generateDefaultCustomField($productId);

                $configOptionSync = new ConfigOptionsSync($productId);
                $configOptionSync->configOptionsSync($configOptionsMultiplier);

                $configOptionSync = new AddonsSync($productId);
                $configOptionSync->addonsSync();

                $messages[] = 'Product "' . $product['name'] . '" has been created';
            }
        }
    }

    echo json_encode([
        'result' => 'success',
        'messages' => $messages,
    ]);
    die();

} catch (Exception $e) {
    echo json_encode([
        'result' => 'error',
        'msg' => $e->getMessage(),
    ]);
}

die();
