<?php

class HostwindsReseller_cpanel_Product
{

    const DB_CONFIGURATION = 'HostwindsReseller_cpanel_conf';

    //Product ID
    public $id;
    //Product Configuration. Should be created in child
    public $defaultConfig = [];
    protected $_config = null;

    public function __construct($id, array $params = [])
    {
        //Copy Params
        foreach ($params as $k => $v) {
            $this->$k = $v;
        }
        $this->id = (int)$id;
    }

    public function runAutoConfiguration()
    {
        //Generate Custom Fields
        if ($_REQUEST['modaction'] == 'generate_custom_fields') {
            ob_clean();
            $ret = $this->generateDefaultCustomField();
            $json = [];
            if ($ret) {
                $json['status'] = 1;
                $json['message'] = 'Custom Fields Generated';
            } else {
                $json['status'] = 0;
                $json['message'] = 'Custom Fields Already Generated';
            }

            echo json_encode($json);
            die();
        }
    }

    /**
     *  Save Product Configuration
     * @param type $customconfigoption
     */
    public function saveConfigOptions($customconfigoption)
    {
        $this->clearConfig();

        foreach ($customconfigoption as $k => $v) {
            $this->saveConfig($k, $v);
        }
    }

    /**
     *  Generate Default Custom Fieds
     * @return boolean
     */
    public function generateDefaultCustomField()
    {
        foreach ($this->defaultCustomField as $key => $field) {
            $q = mysql_query_safe("SELECT id, relid, fieldname
			FROM tblcustomfields
			WHERE
				relid = " . $this->id . "
				AND type = 'product'
				AND (fieldname = '" . $key . "' OR fieldname LIKE '" . $key . "|%') ");

            if (mysql_count_rows($q)) {
                return false;
            }

            switch ($field['type']) {
                case 'text':
                    mysql_query_safe('INSERT INTO tblcustomfields(type,relid,fieldname,fieldtype,description,fieldoptions,regexpr,adminonly,required,showorder,showinvoice,sortorder)
			VALUES("product", ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [
                        $this->id,
                        $key . '|' . $field['title'],
                        "text",
                        $field['description'] ? $field['description'] : '',
                        $field['fieldoptions'] ? $field['fieldoptions'] : '',
                        $field['regexpr'] ? $field['regexpr'] : '',
                        $field['adminonly'] ? 'on' : '',
                        $field['required'] ? 'on' : '',
                        $field['showorder'] ? 'on' : '',
                        $field['showinvoice'] ? 'on' : '',
                        $field['sortorder'] ? ' on' : '',
                    ]);
                    break;
                case 'quantity':
                    mysql_query_safe('INSERT INTO tblproductconfigoptions(gid,optionname,optiontype,qtyminimum,qtymaximum,`order`,hidden) VALUES(?,?,4,?,?,0,0)',
                        [
                            $group_id,
                            $field_key . '|' . $field['title'],
                            $field['min'],
                            $field['max'],
                        ]);
                    break;
                default:
                    die('Unsupported type!');
            }
        }

        return true;
    }

    /**
     * Load Product Configuration
     * @throws Exception
     */
    public function load()
    {
        $q = mysql_query_safe('SELECT * FROM tblproducts WHERE id = ' . (int)$this->id);
        $row = mysql_extract_assoc($q);
        if (!empty($row)) {
            foreach ($row as $k => $v) {
                $this->$k = $v;
            }
        } else {
            throw new Exception('No product to load');
        }
    }

    /**
     *  Load product configuration by service it
     * @param type $serviceid
     */
    public function setIdByServiceId($serviceid)
    {
        $q = mysql_query_safe('SELECT packageid FROM tblhosting WHERE id = ' . (int)$serviceid);
        $row = mysql_extract_assoc($q);
        $this->id = (int)$row['packageid'];
    }

    /**
     * Update product details
     * @param array $values
     * @return type
     */
    public function update(array $values)
    {
        $sets = [];
        foreach ($values as $k => $v) {
            $v = is_numeric($v) ? $v : '' . mysql_escape_quote_string($v) . '';
            $sets[] = $k . '=' . $v;
        }
        return mysql_query_safe('UPDATE tblproducts SET ' . implode(',', $sets) . ' WHERE id = ' . (int)$this->id);
    }

    /**
     * Has Configurable Options?
     * @return type
     */
    public function hasConfigurableOptions()
    {
        $q = mysql_query_safe('SELECT * FROM tblproductconfiglinks WHERE pid = ?', [$this->id]);
        return (bool)mysql_count_rows($q);
    }

    /**
     *
     * @return type
     */
    public function hasAssignedServerGroup()
    {
        $q = mysql_query_safe('SELECT servergroup FROM tblproducts WHERE id = ?', [$this->id]);
        $row = mysql_extract_assoc($q);
        return isset($row['servergroup']) ? (int)$row['servergroup'] : false;
    }

    /**
     *
     * @return type
     */
    public function getParams()
    {
        $params = [];
        $api = unserialize(decrypt(getWHMCSconfig('HostwindsResellerServerConfiguration')));
        if (!empty($api)) {
            $params['serverhostname'] = $api['hostname'];
            $params['serverusername'] = $api['email'];
            $params['serverpassword'] = $api['password'];
        }

        return $params;
    }

    // ========================================
    // ============ CUSTOM CONFIG =============
    // ========================================

    public function getConfig($name)
    {
        $this->loadConfig();
        return isset($this->_config[$name]) ? $this->_config[$name] : null;
    }

    public function issetConfig($name)
    {
        $this->loadConfig();
        return isset($this->_config[$name]);
    }

    public function loadConfig()
    {
        if ($this->_config !== null) {
            return $this->_config;
        }

        self::setupDbTable();
        $q = mysql_query_safe('SELECT * FROM ' . self::DB_CONFIGURATION . ' WHERE product_id = ' . (int)$this->id);
        while ($row = mysql_extract_assoc($q)) {
            if (json_decode($row['value']) !== null) {
                $row['value'] = json_decode($row['value']);
            }

            $this->_config[$row['setting']] = $row['value'];
        }
        return $this->_config;
    }

    public function saveConfig($name, $value)
    {
        if (is_array($value)) {
            $value = json_encode($value);
        }
        return mysql_query_safe('INSERT INTO ' . self::DB_CONFIGURATION . '(setting,product_id,value) VALUES(?,?,?) ON DUPLICATE KEY UPDATE value = ?',
            [
                $name,
                (int)$this->id,
                ($value == '-- not specified --' ? '' : $value),
                $value,
            ]);
    }

    public function clearConfig()
    {
        return mysql_query_safe('DELETE FROM ' . self::DB_CONFIGURATION . ' WHERE product_id = ' . (int)$this->id);
    }

    public function renderConfigOptions($scripts = '')
    {
        $scripts .= '
			<style type="text/css">
			td.configoption_group {background-color:silver;font-weight:bold;text-align:left;}
			.fieldlabel.mg, .fieldarea.mg {width:25%;}
			.fielddescription {font-size: 10px;color: gray;display: inline;}
			</style>
		';

        $str = '';
        $options = [];
        $groups = [];
        $i = 0;
        foreach ($this->defaultConfig as $k => $config) {
            // group html
            if (is_string($config)) {
                $groups[$i] = $config;
                continue;
            }

            if ($k == 'genereate_custom_field') {
                $options[] = '
					<td class="fieldlabel mg">Custom Field</td>
					<td class="fieldarea mg"><a href="#" class="generate_custom_fields">Generate</a></td>';

                $scripts .= '<script type="text/javascript">
								jQuery(function(){
								   jQuery(".generate_custom_fields").click(function(event){
										event.preventDefault();
												jQuery.post(window.location.href, {"modaction":"generate_custom_fields", "productid":' . $this->id . '}, function(res){
												alert(res.message);
												if(res.status)
												{
													window.location.href = "configproducts.php?action=edit&id=' . $this->id . '&tab=3";
												}
										}, "json";)
									});
								});
							 </script>';
            } else {
                $options[] = '
					<td class="fieldlabel mg">' . $config['title'] . '</td>
					<td class="fieldarea mg">
						' . $this->renderConfigOptionInput(
                        $k,
                        $config['type'],
                        isset($config['default']) ? $config['default'] : '',
                        isset($config['options']) ? $config['options'] : [],
                        isset($config['useOptionsKeys']) && $config['useOptionsKeys'],
                        isset($config['disabled']) && $config['disabled']
                    ) . ($i == 0 ? $scripts : '') . '
						' . (isset($config['description']) ? '<div class="fielddescription">' . $config['description'] . '</div>' : '') . '
					</td>';
                $i++;
            }
        }
        $countFields = 0;
        foreach ($options as $k => $option) {
            if ($countFields == 0 && $k != 0) {
                $str .= '<tr>';
            }

            if (isset($groups[$k])) {
                if ($countFields == 1) {
                    $str .= '<td></td><td></td>';
                }
                $str .= '</tr><tr><td colspan="4" class="configoption_group">' . $groups[$k] . '</td></tr><tr>';
                $countFields = 0;
            }
            $str .= $option;

            $countFields++;
            if ($countFields == 2) {
                $str .= '</tr>';
            }
            if ($countFields > 1) {
                $countFields = 0;
            }
        }
        if ($countFields != 0) {
            $str .= '</tr>';
        }
        return $str;
    }

    public function renderConfigOptionInput(
        $name,
        $type,
        $default,
        array $options = [],
        $optionsValuesFromKeys = false,
        $disabled = false
    )
    {
        $value = $this->getConfig($name) ? $this->getConfig($name) : ($this->issetConfig($name) ? '' : $default);
        switch ($type) {
            case 'multiselect':
                $str = '<select name="customconfigoption[' . $name . '][]" multiple style="width:160px;" ' . ($disabled ? 'disabled' : '') . '>';
                foreach ($options as $k => $option) {
                    $str .= '<option value="' . ($optionsValuesFromKeys ? $k : $option) . '" ' . (is_array($value) && in_array(($optionsValuesFromKeys ? $k : $option),
                            $value) ? 'selected' : '') . '>' . $option . '</option>';
                }
                $str .= '</select>';
                return $str;

            case 'select':
                $str = '<select name="customconfigoption[' . $name . ']" style="width:160px;" ' . ($disabled ? 'disabled' : '') . '>';
                foreach ($options as $k => $option) {
                    if (is_array($option)) {
                        $str .= '<optgroup label="' . $k . '">';
                        foreach ($option as $k2 => $sub) {
                            $str .= '<option value="' . ($optionsValuesFromKeys ? $k2 : $sub) . '" ' . ($value == ($optionsValuesFromKeys ? $k2 : $sub) ? 'selected' : '') . '>' . $sub . '</option>';
                        }
                        $str .= '</optgroup>';
                    } else {
                        $str .= '<option value="' . ($optionsValuesFromKeys ? $k : $option) . '" ' . ($value == ($optionsValuesFromKeys ? $k : $option) ? 'selected' : '') . '>' . $option . '</option>';
                    }
                }
                $str .= '</select>';
                return $str;

            case 'text':
                return '<input type="text" name="customconfigoption[' . $name . ']" style="width:150px;" value="' . $value . '" ' . ($disabled ? 'disabled' : '') . ' />';

            case 'textarea':
                return '<textarea name="customconfigoption[' . $name . ']" style="width:100%" ' . ($disabled ? 'disabled' : '') . '>' . $value . '</textarea>';

            case 'radio':
                $str = '';
                foreach ($options as $option) {
                    $str .= '<input type="radio" name="customconfigoption[' . $name . ']" value="' . $option . '" ' . ($disabled ? 'disabled' : '') . ' /> ' . $option;
                }
                return $str;

            case 'checkbox':
                return '<input type="checkbox"  name="customconfigoption[' . $name . ']" value="1"  ' . ($value ? ' checked="checked" ' : '') . ' ' . ($disabled ? 'disabled' : '') . ' /> ' . $option;

            case 'html':
                return $default;

            case 'empty':
                return '';
        }
        throw new Exception('Config Option type not supported');
    }

    public static function setupDbTable()
    {
        return mysql_query_safe('CREATE TABLE IF NOT EXISTS `' . self::DB_CONFIGURATION . '` (
			`setting` varchar(100) NOT NULL,
			`product_id` int(10) UNSIGNED NOT NULL,
			`value` varchar(250) NOT NULL,
			PRIMARY KEY (`setting`,`product_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;');
    }

}
