<?php

class HostwindsReseller_default_Ajax
{

    protected $_params;

    public function processRequest($params)
    {
        if (!$this->isAdmin() && !$this->isClient()) {
            return;
        }

        $this->_params = $params;
        $method = 'call_' . $params['action'];
        call_user_func_array([$this, $method], []);
        $this->sendResponse(false, 'Action does not respond the standard way.');
    }

    public function call_createEmailAccount()
    {
        if (!isset($this->_params['id'])) {
            $this->sendResponse(false, 'No hosting ID param');
        }
        $hosting = new HostwindsReseller_default_Hosting($this->_params['id']);
        $module = HostwindsReseller_default_module::getModule($hosting->hosting_details['packageid']);
        $module->hosting = $hosting;
        $method = 'clientarea_' . $this->_params['action'];

        $vars = $module->$method($this->_params);

        if (isset($vars['success']) && $vars['success']) {
            $this->sendResponse(true, $vars['success']);
        } else {
            $this->sendResponse(false, $vars['error']);
        }

    }

    public function __call($name, $arguments)
    {
        $this->sendResponse(false, 'Action "' . $name . '" is not supported');
    }

    public function isAdmin()
    {
        return isset($_SESSION['adminid']) && $_SESSION['adminid'];
    }

    public function isClient()
    {
        return isset($_SESSION['uid']) && $_SESSION['uid'];
    }

    public function isClientsService($serviceid, $clientid = null)
    {
        $q = mysql_query_safe('SELECT id FROM tblhosting WHERE userid = ? AND id = ?', [
            $clientid ? $clientid : $_SESSION['uid'],
            $serviceid,
        ]);
        $row = mysql_extract_assoc($q);
        return empty($row) ? false : true;
    }

    public function getModule($hosting)
    {
        if (!is_object($hosting) && is_numeric($hosting)) {
            $hosting = new HostwindsReseller_default_Hosting($hosting);
        }

        $module = HostwindsReseller_default_module::getModule($hosting->hosting_details['packageid']);
        $module->params = $module->product->getParams();
        $module->hosting = $hosting;

        return $module;
    }

    public function sendResponse($success, $msg, array $params = [])
    {
        $res = [
            'success' => $success ? 1 : 0,
            'msg' => $msg,
        ];
        ob_clean();
        $str = json_encode(array_merge($res, $params));
        header('Content-Type: application/json');
        header('Content-Length: ' . strlen($str));
        echo $str;
        die();
    }

}
